<?php

require_once(ABSPATH . 'wp-includes/pluggable.php');
$wpvnoption = wpvn_all_options();

add_action('admin_head', 'wpvn_addcss');
function wpvn_addcss() {
	echo '<link rel="stylesheet" type="text/css" href="'. plugin_dir_url( __FILE__ ) . 'css/button-red.css" />';
}

if ($wpvnoption['wpvn_mce'] == 2) {
	if ( ! function_exists( 'wpvn_mce_buttons' ) ) {
		function wpvn_mce_buttons($buttons){
			array_push($buttons,
				 "alignjustify",
				 "subscript",
				 "superscript"
			);
			return $buttons;
		}
		add_filter("mce_buttons", "wpvn_mce_buttons");
	}
	if ( ! function_exists( 'wpvn_mce_buttons_2' ) ) {
		function wpvn_mce_buttons_2($buttons){
			array_push($buttons,
				 "backcolor",
				 "anchor",
				 "fontselect",
				 "fontsizeselect",
				 "cleanup"
			);
			return $buttons;
		}
		add_filter("mce_buttons_2", "wpvn_mce_buttons_2");
	}
	if ( ! function_exists( 'wpvn_text_sizes' ) ) {
	   function wpvn_text_sizes( $initArray ){
		  $initArray['fontsize_formats'] = "9px 10px 12px 13px 14px 16px 17px 18px 19px 20px 21px 24px 28px 32px 36px";
		  return $initArray;
	   }
	   add_filter( 'tiny_mce_before_init', 'wpvn_text_sizes' );
	}
	//Remove tags p and spacebar
	add_filter('the_content', function($content) {
    $content = force_balance_tags($content);
    return preg_replace('/<p>(?:\s|&nbsp;)*?<\/p>/i', '', $content);
	}, 10, 1);
	
} elseif ($wpvnoption['wpvn_mce'] == 3) {
	if (!function_exists( 'wpvn_mce_buttons')){
		function wpvn_mce_buttons($buttons){
			array_push($buttons,
				"alignjustify",
				"subscript",
				"superscript"
			);
			return $buttons;
		}
		add_filter("mce_buttons", "wpvn_mce_buttons");
	}
	if (!function_exists('wpvn_mce_buttons_2')){
		function wpvn_mce_buttons_2($buttons){
			array_push($buttons,
				"fontselect",
				"cleanup"
			);
			return $buttons;
		}
		add_filter("mce_buttons_2", "wpvn_mce_buttons_2", 9999);
	}
	function flatsome_editor_text_sizes($initArray){
		$initArray['fontsize_formats'] = "9px 10px 12px 13px 14px 16px 17px 18px 19px 20px 21px 24px 28px 32px 36px";
		return $initArray;
	}
}

if ($wpvnoption['wpvn_disable_emojis'] == 1) {
	function wpvn_disable_emojis() {
		remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
		remove_action( 'admin_print_scripts', 'print_emoji_detection_script' );
		remove_action( 'wp_print_styles', 'print_emoji_styles' );
		remove_action( 'admin_print_styles', 'print_emoji_styles' ); 
		remove_filter( 'the_content_feed', 'wp_staticize_emoji' );
		remove_filter( 'comment_text_rss', 'wp_staticize_emoji' ); 
		remove_filter( 'wp_mail', 'wp_staticize_emoji_for_email' );
		add_filter( 'tiny_mce_plugins', 'disable_emojis_tinymce' );
	}
	add_action( 'init', 'wpvn_disable_emojis' );
	function wpvn_disable_emojis_tinymce( $plugins ) {
		if ( is_array( $plugins ) ) {
			return array_diff( $plugins, array( 'wpemoji' ) );
		} else {
			return array();
		}
	}
	function wpvn_disable_emojis_remove_dns_prefetch( $urls, $relation_type ) {
		if ( 'dns-prefetch' == $relation_type ) {
		$emoji_svg_url = apply_filters( 'emoji_svg_url', 'https://s.w.org/images/core/emoji/2/svg/' );
		$urls = array_diff( $urls, array( $emoji_svg_url ) );
	}
	return $urls;
	}
}

if ($wpvnoption['wpvn_post_revisions']) {
    $wpvnoption = wpvn_all_options();
    if (!defined('WP_POST_REVISIONS'))
        define('WP_POST_REVISIONS', $wpvnoption['wpvn_post_revisions']);
}

if ($wpvnoption['wpvn_admin_footer']) {
    function wpvn_admin_footer_name()
    {
        $wpvnoption = wpvn_all_options();
        echo '<span id="footer-thankyou">Powered by <a href="' . get_bloginfo('wpurl') . '" target="_blank">' .$wpvnoption['wpvn_admin_footer'].'</a></span>';
    }
    add_filter('admin_footer_text', 'wpvn_admin_footer_name');
}

if ($wpvnoption['wpvn_remove_head_link'] == 1) {
    remove_action('wp_head', 'rsd_link');
    remove_action('wp_head', 'wp_generator');
    remove_action('wp_head', 'feed_links', 2);
    remove_action('wp_head', 'index_rel_link');
    remove_action('wp_head', 'wlwmanifest_link');
    remove_action('wp_head', 'feed_links_extra', 3);
    remove_action('wp_head', 'start_post_rel_link', 10, 0);
    remove_action('wp_head', 'parent_post_rel_link', 10, 0);
    remove_action('wp_head', 'adjacent_posts_rel_link', 10, 0);
}

if ($wpvnoption['wpvn_hide_admin_bar'] == 2) {
    show_admin_bar(false);
    echo '<style type="text/css">#wpadminbar{display:none;}html {position:absolute;top:-28px;}</style>'; 
}
if ($wpvnoption['wpvn_hide_admin_bar'] == 3) {
	add_action('init', 'remove_admin_bar');
	function remove_admin_bar() {
	  if (!current_user_can('administrator') && !is_admin()) {
		show_admin_bar(false);
	  }
	}
}

if ($wpvnoption['wpvn_back_access'] == 1) {
	function redirect_non_admin_user(){
		if ( !defined( 'DOING_AJAX' ) && !current_user_can('administrator') ){
			wp_redirect( site_url() );  exit;
		} 
	}
	add_action( 'admin_init', 'redirect_non_admin_user' );
}


if ($wpvnoption['wpvn_disable_feed'] == 1) {
    function wpvn_disable_feed()
    {
        wp_die(__('No feed available,please visit our <a href="' . get_bloginfo('wpurl') . '">homepage</a>!'));
    }
    add_action('do_feed', 'wpvn_disable_feed', 1);
    add_action('do_feed_rdf', 'wpvn_disable_feed', 1);
    add_action('do_feed_rss', 'wpvn_disable_feed', 1);
    add_action('do_feed_rss2', 'wpvn_disable_feed', 1);
    add_action('do_feed_atom', 'wpvn_disable_feed', 1);
}

if ($wpvnoption['wpvn_enable_gzip'] == 1) {
    if (extension_loaded("zlib") && (ini_get("output_handler") != "ob_gzhandler"))
        add_action('wp', create_function('', '@ob_end_clean();@ini_set("zlib.output_compression", 1);'));
}

if ($wpvnoption['wpvn_disallow_file_edit'] == 1) {
    if (!defined('DISALLOW_FILE_EDIT'))
        define('DISALLOW_FILE_EDIT', true);
}

if ($wpvnoption['wpvn_disallow_file_mods'] == 1) {
    if (!defined('DISALLOW_FILE_MODS'))
        define('DISALLOW_FILE_MODS', true);
}

if ($wpvnoption['wpvn_disable_admin_nag'] == 1) {
    if (!current_user_can('manage_options')) {
        add_action('init', create_function('$a', "remove_action('init', 'wp_version_check');"), 2);
        add_filter('pre_option_update_core', create_function('$a', "return null;"));
    }
}

if ($wpvnoption['wpvn_remove_version'] == 1) {
    function wpvn_remove_version()
    {
        return '';
    }
    add_filter('the_generator', 'wpvn_remove_version');
	//Hide admin footer from admin
	function change_footer_admin () {return ' ';}
	add_filter('admin_footer_text', 'change_footer_admin', 9999);
	function change_footer_version() {return ' ';}
	add_filter( 'update_footer', 'change_footer_version', 9999);
	remove_action('wp_head', 'wp_generator');
	add_filter('the_generator', '__return_empty_string');
	function wpvn_remove_version_scripts_styles($src) {
		if (strpos($src, 'ver=')) {
			$src = remove_query_arg('ver', $src);
		}
		return $src;
	}
	add_filter('style_loader_src', 'wpvn_remove_version_scripts_styles', 9999);
	add_filter('script_loader_src', 'wpvn_remove_version_scripts_styles', 9999);
}

if ($wpvnoption['wpvn_button_post'] == 1) {
    add_action( 'admin_enqueue_scripts', 'posp_enqueue_scripts', 20 );
	function posp_enqueue_scripts() {
		global $pagenow;
		if ( is_admin() && ($pagenow == 'post.php' || $pagenow == 'post-new.php') ) {
			wp_register_script('post-button', plugin_dir_url( __FILE__ ) . 'js/post-button.js', array( 'jquery' ) );
			wp_enqueue_script('post-button');
			wp_enqueue_style('post-button');
			echo '<style type="text/css">.posp_container{background-color:rgba(0,0,0,0.5);width: 113px;height: 50px;z-index: 100;position: fixed;right: 20px;bottom: 20px;display: none;border-radius: 3px;  -moz-border-radius: 3px;-webkit-border-radius: 3px;}.posp_container input {background: #ff2200 !important;margin: 10px auto !important; display: block !important;border-color: #9B2124 #9B2124 #8D1F21 !important; box-shadow: 0 1px 0 #8D1F21 !important;text-shadow: none !important;}</style>'; 
		}
	}
}

if ($wpvnoption['wpvn_remove_gutenberg'] == 1) {
    add_filter('use_block_editor_for_post', '__return_false');
}

if ($wpvnoption['wpvn_allow_svg'] == 1) {
    function add_file_types_to_uploads($file_types){
		$new_filetypes = array();
		$new_filetypes['svg'] = 'image/svg+xml';
		$file_types = array_merge($file_types, $new_filetypes );
		return $file_types;
	}
	add_action('upload_mimes', 'add_file_types_to_uploads');
}

if ($wpvnoption['wpvn_donotcopy'] == 1) {
	if ( ! current_user_can( 'manage_options' ) ) {
    function donotcopy_function() {
		wp_register_script( 'donotcopy', plugin_dir_url( __FILE__ ) . 'js/copy.js', array( 'jquery' ) );
		wp_enqueue_script( 'donotcopy' );
	}
	add_action( 'template_redirect', 'donotcopy_function' );
	}
}

if ($wpvnoption['wpvn_auto_save_images'] == 1) {
    class Auto_Save_Images{
		function __construct(){     
			add_filter( 'content_save_pre',array($this,'post_save_images') ); 
		}
		function post_save_images( $content ){
			if( ($_POST['save'] || $_POST['publish'] )){
				set_time_limit(240);
				global $post;
				$post_id=$post->ID;
				$preg=preg_match_all('/<img.*?src="(.*?)"/',stripslashes($content),$matches);
				if($preg){
					foreach($matches[1] as $image_url){
						if(empty($image_url)) continue;
						$pos=strpos($image_url,$_SERVER['HTTP_HOST']);
						if($pos===false){
							$res=$this->save_images($image_url,$post_id);
							$replace=$res['url'];
							$content=str_replace($image_url,$replace,$content);
						}
					}
				}
			}
			remove_filter( 'content_save_pre', array( $this, 'post_save_images' ) );
			return $content;
		}
		function save_images($image_url,$post_id){
			$file=file_get_contents($image_url);
			$post = get_post($post_id);
			$posttitle = $post->post_title;
			$postname = sanitize_title($posttitle);
			$im_name = "$postname-$post_id.jpg";
			$res=wp_upload_bits($im_name,'',$file);
			$this->insert_attachment($res['file'],$post_id);
			return $res;
		}
		function insert_attachment($file,$id){
			$dirs=wp_upload_dir();
			$filetype=wp_check_filetype($file);
			$attachment=array(
				'guid'=>$dirs['baseurl'].'/'._wp_relative_upload_path($file),
				'post_mime_type'=>$filetype['type'],
				'post_title'=>preg_replace('/\.[^.]+$/','',basename($file)),
				'post_content'=>'',
				'post_status'=>'inherit'
			);
			$attach_id=wp_insert_attachment($attachment,$file,$id);
			$attach_data=wp_generate_attachment_metadata($attach_id,$file);
			wp_update_attachment_metadata($attach_id,$attach_data);
			return $attach_id;
		}
	}
	new Auto_Save_Images();
}

if ($wpvnoption['wpvn_admin_logo'] || $wpvnoption['wpvn_admin_background'] || $wpvnoption['wpvn_admin_button']){
    function custom_admin_login()
	{
        $wpvnoption = wpvn_all_options();
		echo '<link rel="stylesheet" type="text/css" href="'. plugin_dir_url( __FILE__ ) . 'css/admin.css" />';
		echo '<style type="text/css">body.login { background: '. $wpvnoption['wpvn_admin_background'] .'; } .login h1 a { background-image: url(' . $wpvnoption['wpvn_admin_logo'] . '); }.login.wp-core-ui .button-primary { background: '. $wpvnoption['wpvn_admin_button'] .'; border-color: '. $wpvnoption['wpvn_admin_button'] .'; box-shadow: 0 1px 0 '. $wpvnoption['wpvn_admin_button'] .';}</style>';
	}
	add_action('login_head', 'custom_admin_login');
	function custom_login_logo_url() {
		return get_bloginfo( 'url' );
	}
	add_filter( 'login_headerurl', 'custom_login_logo_url' );

	function custom_login_logo_url_title() {
		return get_bloginfo( 'title' );
	}
	add_filter( 'login_headertitle', 'custom_login_logo_url_title' );
}

if ($wpvnoption['wpvn_remove_wp_logo']) {
	add_action( 'admin_bar_menu', 'remove_wp_logo', 999 );
	function remove_wp_logo( $wp_admin_bar ) {
		$wp_admin_bar->remove_node( 'wp-logo' );
	}
}

if ($wpvnoption['wpvn_admin_slug'] == 1) {
	if ( defined( 'ABSPATH' ) && ! class_exists( 'Rename_WP_Login' ) ) {
		class Rename_WP_Login {
			private $wp_login_php;
			private function basename() {
				return plugin_basename( __FILE__ );
			}
			private function path() {
				return trailingslashit( dirname( __FILE__ ) );
			}
			private function use_trailing_slashes() {
				return '/' === substr( get_option( 'permalink_structure' ), -1, 1 );
			}
			private function user_trailingslashit( $string ) {
				return $this->use_trailing_slashes() ? trailingslashit( $string ) : untrailingslashit( $string );
			}
			private function wp_template_loader() {
				global $pagenow;
				$pagenow = 'index.php';
				if ( ! defined( 'WP_USE_THEMES' ) ) {
					define( 'WP_USE_THEMES', true );
				}
				wp();
				if ( $_SERVER['REQUEST_URI'] === $this->user_trailingslashit( str_repeat( '-/', 10 ) ) ) {
					$_SERVER['REQUEST_URI'] = $this->user_trailingslashit( '/wp-login-php/' );
				}
				require_once( ABSPATH . WPINC . '/template-loader.php' );
				die;
			}
			private function new_login_slug() {
				if (
					( $slug = get_option( 'wpvn_slug_page' ) ) || (
						is_multisite() &&
						is_plugin_active_for_network( $this->basename() ) &&
						( $slug = get_site_option( 'wpvn_slug_page', 'login' ) )
					) ||
					( $slug = 'login' )
				) {
					return $slug;
				}
			}
			public function new_login_url( $scheme = null ) {
				if ( get_option( 'permalink_structure' ) ) {
					return $this->user_trailingslashit( home_url( '/', $scheme ) . $this->new_login_slug() );
				} else {
					return home_url( '/', $scheme ) . '?' . $this->new_login_slug();
				}
			}
			public function __construct() {
				global $wp_version;
				if ( version_compare( $wp_version, '5.0', '<' ) ) {
					add_action( 'admin_notices', array( $this, 'admin_notices_incompatible' ) );
					add_action( 'network_admin_notices', array( $this, 'admin_notices_incompatible' ) );
					return;
				}
				register_activation_hook( $this->basename(), array( $this, 'activate' ) );
				register_uninstall_hook( $this->basename(), array( 'Rename_WP_Login', 'uninstall' ) );
				add_action( 'admin_init', array( $this, 'admin_init' ) );
				add_action( 'admin_notices', array( $this, 'admin_notices' ) );
				add_action( 'network_admin_notices', array( $this, 'admin_notices' ) );
				if ( is_multisite() && ! function_exists( 'is_plugin_active_for_network' ) ) {
					require_once( ABSPATH . '/wp-admin/includes/plugin.php' );
				}
				add_filter( 'plugin_action_links_' . $this->basename(), array( $this, 'plugin_action_links' ) );
				if ( is_multisite() && is_plugin_active_for_network( $this->basename() ) ) {
					add_filter( 'network_admin_plugin_action_links_' . $this->basename(), array( $this, 'plugin_action_links' ) );
					add_action( 'wpmu_options', array( $this, 'wpmu_options' ) );
					add_action( 'update_wpmu_options', array( $this, 'update_wpmu_options' ) );
				}
				add_action( 'plugins_loaded', array( $this, 'plugins_loaded' ), 1 );
				add_action( 'wp_loaded', array( $this, 'wp_loaded' ) );
				add_filter( 'site_url', array( $this, 'site_url' ), 10, 4 );
				add_filter( 'network_site_url', array( $this, 'network_site_url' ), 10, 3 );
				add_filter( 'wp_redirect', array( $this, 'wp_redirect' ), 10, 2 );
				add_filter( 'site_option_welcome_email', array( $this, 'welcome_email' ) );
				remove_action( 'template_redirect', 'wp_redirect_admin_locations', 1000 );
			}
			public function admin_notices_incompatible() {
				echo '<div class="error"><p>' . sprintf( __( 'Please upgrade to the latest version of WordPress to activate %s.', 'wpvn' ), '<strong>' . __( 'Rename wp-login.php', 'wpvn' ) . '</strong>' ) . '</p></div>';
			}
			public function activate() {
				add_option( 'wpvn_slug_redirect', '1' );
				delete_option( 'wpvn_slug_admin' );
			}
			public static function uninstall() {
				global $wpdb;
				if ( is_multisite() ) {
					$blogs = $wpdb->get_col( "SELECT blog_id FROM {$wpdb->blogs}" );
					if ( $blogs ) {
						foreach ( $blogs as $blog ) {
							switch_to_blog( $blog );
							delete_option( 'wpvn_slug_page' );
						}
						restore_current_blog();
					}
					delete_site_option( 'wpvn_slug_page' );
				} else {
					delete_option( 'wpvn_slug_page' );
				}
			}
			public function wpmu_options() {
				$out = '';
				$out .= '<h3>' . __( 'Rename wp-login.php', 'wpvn' ) . '</h3>';
				$out .= '<p>' . __( 'This option allows you to set a networkwide default, which can be overridden by individual sites. Simply go to to the site’s permalink settings to change the url.', 'wpvn' ) . '</p>';
				$out .= '<table class="form-table">';
					$out .= '<tr valign="top">';
						$out .= '<th scope="row">' . __( 'Networkwide default', 'wpvn' ) . '</th>';
						$out .= '<td><input id="wpvn_slug-page-input" type="text" name="wpvn_slug_page" value="' . get_site_option( 'wpvn_slug_page', 'login' )  . '"></td>';
					$out .= '</tr>';
				$out .= '</table>';

				echo $out;
			}
			public function update_wpmu_options() {
				if (
					( $wpvn_slug_page = sanitize_title_with_dashes( $_POST['wpvn_slug_page'] ) ) &&
					strpos( $wpvn_slug_page, 'wp-login' ) === false &&
					! in_array( $wpvn_slug_page, $this->forbidden_slugs() )
				) {
					update_site_option( 'wpvn_slug_page', $wpvn_slug_page );
				}
			}
			public function admin_init() {
				global $pagenow;
				add_settings_section(
					'slug-wp-login-section',
					__( 'Custom wp-login.php & wp-admin', 'wpvn' ),
					array( $this, 'wpvn_slug_section_desc' ),
					'permalink'
				);
				add_settings_field(
					'wpvn_slug-page',
					'<label for="wpvn_slug-page">' . __( 'Login URL', 'wpvn' ) . '</label>',
					array( $this, 'wpvn_slug_page_input' ),
					'permalink',
					'slug-wp-login-section'
				);
				if ( isset( $_POST['wpvn_slug_page'] ) && $pagenow === 'options-permalink.php' ) {
					if (
						( $wpvn_slug_page = sanitize_title_with_dashes( $_POST['wpvn_slug_page'] ) ) &&
						strpos( $wpvn_slug_page, 'wp-login' ) === false &&
						! in_array( $wpvn_slug_page, $this->forbidden_slugs() )
					) {
						if ( is_multisite() && $wpvn_slug_page === get_site_option( 'wpvn_slug_page', 'login' ) ) {
							delete_option( 'wpvn_slug_page' );
						} else {
							update_option( 'wpvn_slug_page', $wpvn_slug_page );
						}
					}
				}
				if ( get_option( 'wpvn_slug_redirect' ) ) {
					delete_option( 'wpvn_slug_redirect' );
					if ( is_multisite() && is_super_admin() && is_plugin_active_for_network( $this->basename() ) ) {
						$redirect = network_admin_url( 'settings.php#wpvn_slug-page-input' );
					} else {
						$redirect = admin_url( 'options-permalink.php#wpvn_slug-page-input' );
					}
					wp_safe_redirect( $redirect );
					die;
				}
			}
			public function wpvn_slug_section_desc() {
				$out = '';
				if ( is_multisite() && is_super_admin() && is_plugin_active_for_network( $this->basename() ) ) {
					$out .= '<p>' . sprintf( __( 'To set a networkwide default, go to %s.', 'wpvn' ), '<a href="' . network_admin_url( 'settings.php#wpvn_slug-page-input' ) . '">' . __( 'Network Settings', 'wpvn' ) . '</a>') . '</p>';
				}
				echo $out;
			}
			public function wpvn_slug_page_input() {
				if ( get_option( 'permalink_structure' ) ) {
					echo '<code>' . trailingslashit( home_url() ) . '</code> <input id="wpvn_slug-page-input" type="text" name="wpvn_slug_page" value="' . $this->new_login_slug()  . '">' . ( $this->use_trailing_slashes() ? ' <code>/</code>' : '' );
				} else {
					echo '<code>' . trailingslashit( home_url() ) . '?</code> <input id="wpvn_slug-page-input" type="text" name="wpvn_slug_page" value="' . $this->new_login_slug()  . '">';
				}
			}
			public function admin_notices() {
				global $pagenow;
				if ( ! is_network_admin() && $pagenow === 'options-permalink.php' && isset( $_GET['settings-updated'] ) ) {
					echo '<div class="updated"><p>' . sprintf( __( 'Your login page is now here: %s. Bookmark this page!', 'wpvn' ), '<strong><a href="' . $this->new_login_url() . '">' . $this->new_login_url() . '</a></strong>' ) . '</p></div>';
				}
			}
			public function plugin_action_links( $links ) {
				if ( is_network_admin() && is_plugin_active_for_network( $this->basename() ) ) {
					array_unshift( $links, '<a href="' . network_admin_url( 'settings.php#wpvn_slug-page-input' ) . '">' . __( 'Settings', 'wpvn' ) . '</a>' );
				} elseif ( ! is_network_admin() ) {
					array_unshift( $links, '<a href="' . admin_url( 'options-permalink.php#wpvn_slug-page-input' ) . '">' . __( 'Settings', 'wpvn' ) . '</a>' );
				}
				return $links;
			}
			public function plugins_loaded() {
				global $pagenow;
				load_plugin_textdomain( 'wpvn' );
				if (
					! is_multisite() && (
						strpos( $_SERVER['REQUEST_URI'], 'wp-signup' ) !== false ||
						strpos( $_SERVER['REQUEST_URI'], 'wp-activate' ) !== false
					)
				) {
					wp_die( __( 'This feature is not enabled.', 'wpvn' ) );
				}
				$request = parse_url( $_SERVER['REQUEST_URI'] );
				if ( (
						strpos( $_SERVER['REQUEST_URI'], 'wp-login.php' ) !== false ||
						untrailingslashit( $request['path'] ) === site_url( 'wp-login', 'relative' )
					) &&
					! is_admin()
				) {
					$this->wp_login_php = true;
					$_SERVER['REQUEST_URI'] = $this->user_trailingslashit( '/' . str_repeat( '-/', 10 ) );
					$pagenow = 'index.php';
				} elseif (
					untrailingslashit( $request['path'] ) === home_url( $this->new_login_slug(), 'relative' ) || (
						! get_option( 'permalink_structure' ) &&
						isset( $_GET[$this->new_login_slug()] ) &&
						empty( $_GET[$this->new_login_slug()] )
				) ) {
					$pagenow = 'wp-login.php';
				}
			}
			public function wp_loaded() {
				global $pagenow;
				if ( is_admin() && ! is_user_logged_in() && ! defined( 'DOING_AJAX' ) ) {
					wp_die( __( 'You must log in to access the admin area.', 'wpvn' ) );
				}
				$request = parse_url( $_SERVER['REQUEST_URI'] );
				if (
					$pagenow === 'wp-login.php' &&
					$request['path'] !== $this->user_trailingslashit( $request['path'] ) &&
					get_option( 'permalink_structure' )
				) {
					wp_safe_redirect( $this->user_trailingslashit( $this->new_login_url() ) . ( ! empty( $_SERVER['QUERY_STRING'] ) ? '?' . $_SERVER['QUERY_STRING'] : '' ) );
					die;
				} elseif ( $this->wp_login_php ) {
					if (
						( $referer = wp_get_referer() ) &&
						strpos( $referer, 'wp-activate.php' ) !== false &&
						( $referer = parse_url( $referer ) ) &&
						! empty( $referer['query'] )
					) {
						parse_str( $referer['query'], $referer );
						if (
							! empty( $referer['key'] ) &&
							( $result = wpmu_activate_signup( $referer['key'] ) ) &&
							is_wp_error( $result ) && (
								$result->get_error_code() === 'already_active' ||
								$result->get_error_code() === 'blog_taken'
						) ) {
							wp_safe_redirect( $this->new_login_url() . ( ! empty( $_SERVER['QUERY_STRING'] ) ? '?' . $_SERVER['QUERY_STRING'] : '' ) );
							die;
						}
					}
					$this->wp_template_loader();
				} elseif ( $pagenow === 'wp-login.php' ) {
					global $error, $interim_login, $action, $user_login;
					@require_once ABSPATH . 'wp-login.php';
					die;
				}
			}
			public function site_url( $url, $path, $scheme, $blog_id ) {
				return $this->filter_wp_login_php( $url, $scheme );
			}
			public function network_site_url( $url, $path, $scheme ) {
				return $this->filter_wp_login_php( $url, $scheme );
			}
			public function wp_redirect( $location, $status ) {
				return $this->filter_wp_login_php( $location );
			}
			public function filter_wp_login_php( $url, $scheme = null ) {
				if ( strpos( $url, 'wp-login.php' ) !== false ) {
					if ( is_ssl() ) {
						$scheme = 'https';
					}
					$args = explode( '?', $url );
					if ( isset( $args[1] ) ) {
						parse_str( $args[1], $args );
						$url = add_query_arg( $args, $this->new_login_url( $scheme ) );
					} else {
						$url = $this->new_login_url( $scheme );
					}
				}
				return $url;
			}
			public function welcome_email( $value ) {
				return $value = str_replace( 'wp-login.php', trailingslashit( get_site_option( 'wpvn_slug_page', 'login' ) ), $value );
			}
			public function forbidden_slugs() {
				$wp = new WP;
				return array_merge( $wp->public_query_vars, $wp->private_query_vars );
			}
		}
		new Rename_WP_Login;
	}
}

if ($wpvnoption['wpvn_remove_help'] == 1) {
	add_filter( 'contextual_help', 'wpvn_remove_help_tabs', 999, 3 );
	function wpvn_remove_help_tabs($old_help, $screen_id, $screen){
		$screen->remove_help_tabs();
		return $old_help;
	}
}

if ($wpvnoption['wpvn_remove_show_screen'] == 1) {
	add_filter('screen_options_show_screen', '__return_false');
}

if ($wpvnoption['wpvn_remove_dashboard'] == 1) {
	remove_action('welcome_panel', 'wp_welcome_panel');
	function remove_default_dashboard_widgets() {
		remove_meta_box( 'dashboard_browser_nag', 'dashboard', 'normal' );
		remove_meta_box( 'dashboard_right_now', 'dashboard', 'normal' );
		remove_meta_box( 'dashboard_recent_comments', 'dashboard', 'normal' );
		remove_meta_box( 'dashboard_incoming_links', 'dashboard', 'normal' );
		remove_meta_box( 'dashboard_plugins', 'dashboard', 'normal' );
		remove_meta_box( 'dashboard_quick_press', 'dashboard', 'side' );
		remove_meta_box( 'dashboard_recent_drafts', 'dashboard', 'side' );
		remove_meta_box( 'dashboard_primary', 'dashboard', 'side' );
		remove_meta_box( 'dashboard_secondary', 'dashboard', 'side' );
	} 
	add_action('wp_dashboard_setup', 'remove_default_dashboard_widgets' );
}

if ($wpvnoption['wpvn_dashboard_notice']) {
	function add_dashboard_widgets(){
		//remove_meta_box('dashboard_activity', 'dashboard', 'normal');
		global $wp_meta_boxes;
		wp_add_dashboard_widget('custom_help_widget', 'Notice', 'custom_dashboard_help');
		}
		function custom_dashboard_help() {
		$wpvnoption = wpvn_all_options();
		echo stripslashes($wpvnoption['wpvn_dashboard_notice']);
	}
	add_action('wp_dashboard_setup', 'add_dashboard_widgets');
}

if ($wpvnoption['wpvn_copyright'] == 0) {
	function custom_adminbar_menu( $meta = true ) {  
		global $wp_admin_bar;  
			if ( !is_user_logged_in() ) { return; }  
			if ( !is_super_admin() || !is_admin_bar_showing() ) { return; }  
			$wp_admin_bar->add_menu( array(   
				'id'     => 'wpse',  
				'title' => __( '❤ Donate WP Extra', 'wpvn' ),
				'href' => 'https://www.paypal.me/wordpressvn',
				'meta'  => array( 'target' => '_blank' ) )
			);  
	}  
	add_action( 'admin_bar_menu', 'custom_adminbar_menu', 150 );  
    //add_filter( 'update_footer', function() { echo '❤ C.O.P';}, 11 );
}

if ($wpvnoption['wpvn_avatar_defaults']) {
	$wpvnoption = wpvn_all_options();
	add_filter( 'avatar_defaults', 'wpvn_new_gravatar' );
	function wpvn_new_gravatar ($avatar_defaults) {
	$myavatar = $wpvnoption['wpvn_avatar_defaults'];
	$avatar_defaults[$myavatar] = "Default Gravatar";
	return $avatar_defaults;
	}
}

if ($wpvnoption['wpvn_disable_xmlrpc'] == 1) {
	add_filter('xmlrpc_enabled', '__return_false');
}

if ($wpvnoption['wpvn_shortcode']) {
	function shortcode_myinfo() {
		$wpvnoption = wpvn_all_options();
		return stripslashes($wpvnoption['wpvn_shortcode']);
	}
	add_shortcode('wpextra', 'shortcode_myinfo');
}
if ($wpvnoption['wpvn_auto_update'] == 1) {
	add_filter( 'auto_update_core', '__return_false' );
	add_filter( 'auto_update_translation', '__return_false' );
}
if ($wpvnoption['wpvn_add_header']) {
	function wpvn_add_header_code () {
        $wpvnoption = wpvn_all_options();
		echo stripslashes($wpvnoption['wpvn_add_header']);
	}
	add_action('wp_head', 'wpvn_add_header_code');
}
if ($wpvnoption['wpvn_add_footer']) {
	function wpvn_add_footer_code () {
        $wpvnoption = wpvn_all_options();
		echo stripslashes($wpvnoption['wpvn_add_footer']);
	}
	add_action('wp_footer', 'wpvn_add_footer_code');
}

if ($wpvnoption['wpvn_set_image_meta'] == 1) {
	add_action( 'add_attachment', 'wpvn_set_image_meta_image_upload' );
	function wpvn_set_image_meta_image_upload( $post_ID ) {
		if ( wp_attachment_is_image( $post_ID ) ) {
		$my_image_title = get_post( $post_ID )->post_title;
		$my_image_title = preg_replace( '%\s*[-_\s]+\s*%', ' ',
		$my_image_title );
		$my_image_title = ucwords( strtolower( $my_image_title ) );
		$my_image_meta = array(
		'ID' => $post_ID,
		'post_title' => $my_image_title,
		'post_excerpt' => $my_image_title,
		'post_content' => $my_image_title,
		);
		// Set the image Alt-Text
		update_post_meta( $post_ID, '_wp_attachment_image_alt',
		$my_image_title );
		// Set the image meta (e.g. Title, Excerpt, Content)
		wp_update_post( $my_image_meta );
		}
	}
}

if ($wpvnoption['wpvn_user_gmail'] || $wpvnoption['wpvn_pass_gmail']) {
	function send_smtp_email( $phpmailer ) {
		$wpvnoption = wpvn_all_options();
		$phpmailer->IsSMTP();
		$phpmailer->Host       = "smtp.gmail.com";
		$phpmailer->Port       = 465;
		$phpmailer->SMTPAuth   = true;
		$phpmailer->Username   = $wpvnoption['wpvn_user_gmail'];
		$phpmailer->Password   = $wpvnoption['wpvn_pass_gmail'];
		$phpmailer->SMTPSecure = "ssl";
	}
	add_action( 'phpmailer_init', 'send_smtp_email' );
}

if ($wpvnoption['wpvn_page_html'] == 1) {
	add_action('init', 'htmlPage_permalink', -1);
	function noPage_slash($string, $type){
	   global $wp_rewrite;
		if ($wp_rewrite->using_permalinks() && $wp_rewrite->use_trailing_slashes==true && $type == 'page'){
			return untrailingslashit($string);
	  }else{
	   return $string;
	  }
	}
	function htmlPage_permalink() {
		global $wp_rewrite;
	 if ( !strpos($wp_rewrite->get_page_permastruct(), '.html')){
			$wp_rewrite->page_structure = $wp_rewrite->page_structure . '.html';
	 }
	}
	add_filter('user_trailingslashit', 'noPage_slash',66,2);
	function active() {
		global $wp_rewrite;
		if ( !strpos($wp_rewrite->get_page_permastruct(), '.html')){
			$wp_rewrite->page_structure = $wp_rewrite->page_structure . '.html';
	 }
	  $wp_rewrite->flush_rules();
	}	
	function deactive() {
		global $wp_rewrite;
		$wp_rewrite->page_structure = str_replace(".html","",$wp_rewrite->page_structure);
		$wp_rewrite->flush_rules();
	}
}

if ($wpvnoption['wpvn_clone_post'] == 1) {
	function wpvn_clone_post_as_draft(){
		global $wpdb;
		if (! ( isset( $_GET['post']) || isset( $_POST['post'])  || ( isset($_REQUEST['action']) && 'wpvn_clone_post_as_draft' == $_REQUEST['action'] ) ) ) {
			wp_die('No post to clone has been supplied!');
		}
		if ( !isset( $_GET['clone_nonce'] ) || !wp_verify_nonce( $_GET['clone_nonce'], basename( __FILE__ ) ) )
			return;
		$post_id = (isset($_GET['post']) ? absint( $_GET['post'] ) : absint( $_POST['post'] ) );
		$post = get_post( $post_id );
		$current_user = wp_get_current_user();
		$new_post_author = $current_user->ID;
		if (isset( $post ) && $post != null) {
			$args = array(
				'comment_status' => $post->comment_status,
				'ping_status'    => $post->ping_status,
				'post_author'    => $new_post_author,
				'post_content'   => $post->post_content,
				'post_excerpt'   => $post->post_excerpt,
				'post_name'      => $post->post_name,
				'post_parent'    => $post->post_parent,
				'post_password'  => $post->post_password,
				'post_status'    => 'draft',
				'post_title'     => $post->post_title,
				'post_type'      => $post->post_type,
				'to_ping'        => $post->to_ping,
				'menu_order'     => $post->menu_order
			);
			$new_post_id = wp_insert_post( $args );
			$taxonomies = get_object_taxonomies($post->post_type); // returns array of taxonomy names for post type, ex array("category", "post_tag");
			foreach ($taxonomies as $taxonomy) {
				$post_terms = wp_get_object_terms($post_id, $taxonomy, array('fields' => 'slugs'));
				wp_set_object_terms($new_post_id, $post_terms, $taxonomy, false);
			}
			$post_meta_infos = $wpdb->get_results("SELECT meta_key, meta_value FROM $wpdb->postmeta WHERE post_id=$post_id");
			if (count($post_meta_infos)!=0) {
				$sql_query = "INSERT INTO $wpdb->postmeta (post_id, meta_key, meta_value) ";
				foreach ($post_meta_infos as $meta_info) {
					$meta_key = $meta_info->meta_key;
					if( $meta_key == '_wp_old_slug' ) continue;
					$meta_value = addslashes($meta_info->meta_value);
					$sql_query_sel[]= "SELECT $new_post_id, '$meta_key', '$meta_value'";
				}
				$sql_query.= implode(" UNION ALL ", $sql_query_sel);
				$wpdb->query($sql_query);
			}
			wp_redirect( admin_url( 'post.php?action=edit&post=' . $new_post_id ) );
			exit;
		} else {
			wp_die('Post creation failed, could not find original post: ' . $post_id);
		}
	}
	add_action( 'admin_action_wpvn_clone_post_as_draft', 'wpvn_clone_post_as_draft' );
	function wpvn_clone_post_link( $actions, $post ) {
		if (current_user_can('edit_posts')) {
			$actions['clone'] = '<a href="' . wp_nonce_url('admin.php?action=wpvn_clone_post_as_draft&post=' . $post->ID, basename(__FILE__), 'clone_nonce' ) . '" title="Clone this item" rel="permalink">Clone</a>';
		}
		return $actions;
	}
	add_filter('post_row_actions', 'wpvn_clone_post_link', 10, 2);
	add_filter('page_row_actions', 'wpvn_clone_post_link', 10, 2);
}

if ($wpvnoption['wpvn_ssl'] == 1) {
	//ADD SSL
	function wpvn_force_https () {
	  if ( !is_ssl() ) {
		wp_redirect('https://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'], 301 );
		exit();
	  }
	}
	add_action ( 'template_redirect', 'wpvn_force_https', 1 );

	function protcol_relative_url_srcset($sources)
	{
		foreach ($sources as &$source) {
			$link = str_replace("http://", "//", $source['url']);
			$link = str_replace("https://", "//", $link);
			$source['url'] = $link;
		}
		return $sources;
	}
	function callback_protcol_relative_url($buffer)
	{
		$re     = "/(<(script|link|base|img|form|a)([^>]*)(href|src|srcset|action)=[\"'])https?:\\/\\//i";
		$subst  = "$1//";
		$return = preg_replace($re, $subst, $buffer);
		if ($return) {
			$buffer = $return;
		}
		return $buffer;
	}
	function buffer_start_protcol_relative_url()
	{
		ob_start('callback_protcol_relative_url');
	}
	function buffer_end_protcol_relative_url()
	{
		ob_end_flush();
	}
	add_filter('wp_calculate_image_srcset', 'protcol_relative_url_srcset');
	add_action('wp_loaded', 'buffer_start_protcol_relative_url' , 99, 1);
	add_action('shutdown', 'buffer_end_protcol_relative_url');
}

if ($wpvnoption['wpvn_disable_comments'] == 1) {
	function wpvn_disable_comments_post_types_support() {
		$post_types = get_post_types();
		foreach ($post_types as $post_type) {
			if(post_type_supports($post_type, 'comments')) {
				remove_post_type_support($post_type, 'comments');
				remove_post_type_support($post_type, 'trackbacks');
			}
		}
	}
	add_action('admin_init', 'wpvn_disable_comments_post_types_support');
	// Close comments on the front-end
	function wpvn_disable_comments_status() {
		return false;
	}
	add_filter('comments_open', 'wpvn_disable_comments_status', 20, 2);
	add_filter('pings_open', 'wpvn_disable_comments_status', 20, 2);
	// Hide existing comments
	function wpvn_disable_comments_hide_existing_comments($comments) {
		$comments = array();
		return $comments;
	}
	add_filter('comments_array', 'wpvn_disable_comments_hide_existing_comments', 10, 2);
	// Remove comments page in menu
	function wpvn_disable_comments_admin_menu() {
		remove_menu_page('edit-comments.php');
	}
	add_action('admin_menu', 'wpvn_disable_comments_admin_menu');
	// Redirect any user trying to access comments page
	function wpvn_disable_comments_admin_menu_redirect() {
		global $pagenow;
		if ($pagenow === 'edit-comments.php') {
			wp_redirect(admin_url()); exit;
		}
	}
	add_action('admin_init', 'wpvn_disable_comments_admin_menu_redirect');
	// Remove comments metabox from dashboard
	function wpvn_disable_comments_dashboard() {
		remove_meta_box('dashboard_recent_comments', 'dashboard', 'normal');
	}
	add_action('admin_init', 'wpvn_disable_comments_dashboard');
	// Remove comments links from admin bar
	function remove_comments(){
			global $wp_admin_bar;
			$wp_admin_bar->remove_menu('comments');
	}
	add_action( 'wp_before_admin_bar_render', 'remove_comments' );
}

if ($wpvnoption['wpvn_remove_menu_tools'] == 1) {
	/* Remove Tools admin menu item for everyone other than Administrator */
	add_action( 'admin_init', 'remove_menu_pages_for_all_except_admin' );
		function remove_menu_pages_for_all_except_admin() {
	remove_menu_page('tools.php', 'tools.php');
	}
}

if ($wpvnoption['wpvn_image_limit'] || $wpvnoption['wpvn_image_maximum_height'] || $wpvnoption['wpvn_image_maximum_width']) {
	add_filter('wp_handle_upload_prefilter','wpvn_validate_image_size');
	function wpvn_validate_image_size( $file ) {
		$wpvnoption = wpvn_all_options();
		if ($wpvnoption['wpvn_image_limit']){
			$image_size = $file['size'] / 1024;
			$limit = $wpvnoption['wpvn_image_limit'];
			$is_image = strpos($file['type'], 'image');
			if ( ( $image_size > $limit ) && ($is_image !== false) ) {
				$file['error'] = 'Your picture is too large. It has to be smaller than '. $limit .'KB';
				return $file;
			}
		}
		if ($wpvnoption['wpvn_image_maximum_height'] || $wpvnoption['wpvn_image_maximum_width']) {
			$image = getimagesize($file['tmp_name']);
			$maximum = array(
				'width' => $wpvnoption['wpvn_image_maximum_width'],
				'height' => $wpvnoption['wpvn_image_maximum_height']
			);
			$image_width = $image[0];
			$image_height = $image[1];
			$too_large = "Image dimensions are too large. Maximum size is {$maximum['width']} by {$maximum['height']} pixels. Uploaded image is $image_width by $image_height pixels.";
			if ( $image_width > $maximum['width'] || $image_height > $maximum['height'] ) {
				//add in the field 'error' of the $file array the message
				$file['error'] = $too_large; 
				return $file;
			}
			else
				return $file;
		}
	}
}
if ($wpvnoption['wpvn_image_quality']) {
	add_filter( 'jpeg_quality', 'image_quality');
	function image_quality() {
		$wpvnoption = wpvn_all_options();
		return $wpvnoption['wpvn_image_quality'];
	}
}

?>