<?php
/*
Plugin Name: WP Extra
Plugin URI: https://wordpressvn.com/plugin-wp-extra/
Description: ❤ This is a simple and perfect tool to use as your website’s functionality plugin. Awesome !!!
Version: 1.0
Author: WPVN Team
Author URI: https://wordpressvn.com
Text Domain: wpvn
License: GPLv2
*/
require('wp-extra-aio.php');
add_action('admin_menu', 'add_wpvn_menu');
add_action('plugins_loaded', 'wpvn_translation');
add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'add_action_links' );
function add_action_links ( $links ) {
	$mylinks = array(
	'<a href="' . admin_url( 'admin.php?page=wp-extra' ) . '">' . __( 'Settings' ) . '</a>',
	);
return array_merge( $links, $mylinks );
}


function add_wpvn_menu()
{
    //add_options_page('WP Functions', 'WP Functions', 'manage_options', basename(__FILE__), 'wpvn_menu_page');
	add_menu_page('WP Extra', 'WP Extra', 'manage_options', 'wp-extra', 'wpvn_menu_page','dashicons-heart', 30);
}

function wpvn_translation()
{
    $plugin_dir = basename(dirname(__FILE__));
    load_plugin_textdomain('wpvn', false, $plugin_dir . '/languages/');
}

function wpvn_menu_page()
{
    if (wpvnsave())
        echo "<div id='message' class='updated fade'><p>" . __("Options successfully saved. Please <a href='#' onClick='window.location.reload()'>click refresh</a> this page.", "wpvn") . "</p></div>";
    $wpvnoption = wpvn_all_options();
	$args =   array(
		'wpautop' => true,
		'tinymce'       => array(
			'toolbar1'      => 'formatselect,bold,italic,underline,bullist,numlist,link,unlink,blockquote,forecolor,separator,alignleft,aligncenter,alignright,undo,redo',
			'toolbar2'      => '',
			'toolbar3'      => '',
		),
		'editor_height' => 120,
	);
	echo "<style>sup {background: #ff2200; border-radius:2px; padding: 2px 4px; font-size:8px; color: #fff;}.clear-option {float:right; margin-right: 10px;}</style>";
    echo "<div class='wrap'>
          <h2 align='center'>" . __(" WP Extra Option <sup>1.0</sup>", "wpvn") . " - <a href='https://www.paypal.me/wordpressvn' target='_blank'>Donate WPVN Team</a></h2>
		  <h3 align='center'>" . __(" → Click <a href='#' onClick='window.location.reload()'>Refesh</a> / F5 after  \"Save Options\" !!!", "wpvn") . "</h3>
          <form id='wpvn_save_options' name='wpvn_save_options' method='post' action=''>
          <table cellpadding='10'>
		  <tr>
		  
		  <td valign='top' width='50%'>
          <table class='widefat' style='border:1px solid #0073aa;'>
          <thead style='background: #0073aa;'><th colspan='2'><font color='#fff'>WP Frontend</font></th></tr>
          </thead>
		  
		  <tr><td width='50%'>" . __("Disable Gutenberg", "wpvn") . "<br /><small>Disables the new Gutenberg Editor</small></td><td><input type='checkbox' name='wpvn_remove_gutenberg' value='1' " . checked($wpvnoption['wpvn_remove_gutenberg'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Customize MCE editor (Ex: Justify, Font Size)", "wpvn") . "<br /><small>We removed WordPress’s default editor useless controls and added more useful controls.</small></td><td>
		  <select name='wpvn_mce'>
				<option value='1' ". selected( $wpvnoption['wpvn_mce'], 1 , false) .">None</option>
				<option value='2' ". selected( $wpvnoption['wpvn_mce'], 2 , false) .">MCE editor</option>
				<option value='3' ". selected( $wpvnoption['wpvn_mce'], 3 , false) .">MCE editor (Flatsome)</option>
			</select></td></tr>
		  
		  <tr bgcolor='#efefef'><td>" . __("Auto Save Images", "wpvn") . " <sup>PRO</sup><br /><small>Downloading automatically image from a post to gallery</small></td><td><input type='checkbox' name='wpvn_auto_save_images' value='1' " . checked($wpvnoption['wpvn_auto_save_images'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Publish Button", "wpvn") . "<br /><small>Making it stick to the bottom of the page when scrolling down the page</small></td><td><input type='checkbox' name='wpvn_button_post' value='1' " . checked($wpvnoption['wpvn_button_post'], '1', false) . " /></td></tr>
		  
		  <tr bgcolor='#efefef'><td>" . __("Clone Post / Page", "wpvn") . " <sup>PRO</sup><br /><small>Creates post clone as a draft and redirects then to the edit post screen</small></td><td><input type='checkbox' name='wpvn_clone_post' value='1' " . checked($wpvnoption['wpvn_clone_post'], '1', false) . " /></td></tr>
		  
		  <tr bgcolor='#efefef'><td>" . __("Do Not Copy", "wpvn") . " <sup>PRO</sup><br /><small>Restrict user to copy content & disable mouse right click</small></td><td><input type='checkbox' name='wpvn_donotcopy' value='1' " . checked($wpvnoption['wpvn_donotcopy'], '1', false) . " /></td></tr>
		  
		  <tr><td>" . __("Allow SVG", "wpvn") . "</td><td><input type='checkbox' name='wpvn_allow_svg' value='1' " . checked($wpvnoption['wpvn_allow_svg'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Disable Emojis", "wpvn") . "</td><td><input type='checkbox' name='wpvn_disable_emojis' value='1' " . checked($wpvnoption['wpvn_disable_emojis'], '1', false) . " /> </td></tr>
		  
		  <tr bgcolor='#efefef'><td>" . __("SEO Images", "wpvn") . " <sup>PRO</sup><br /><small>" . __("Automatically set the image Title, Alt-Text, Caption & Description upload", "wpvn") . "</small></td><td><input type='checkbox' name='wpvn_set_image_meta' value='1' " . checked($wpvnoption['wpvn_set_image_meta'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Image Size in kilobytes", "wpvn") . " <br /><small>" . __("Limit Image Size in WordPress Media Library. Ex: 2000 = 2MB", "wpvn") . "</small></td><td><input type='text' size='10' name='wpvn_image_limit' value='" . $wpvnoption['wpvn_image_limit'] . "' /> </td></tr>
		  
		  <tr><td>" . __("Max image dimensions", "wpvn") . " <br /><small>" . __("Maximum width x height. Recommended values: <code>1000x1000</code>", "wpvn") . "</small></td><td><input type='text' size='10' name='wpvn_image_maximum_width' value='" . $wpvnoption['wpvn_image_maximum_width'] . "' /> <input type='text' size='10' name='wpvn_image_maximum_height' value='" . $wpvnoption['wpvn_image_maximum_height'] . "' /> px</td></tr>
		  
		  <tr><td>" . __("Image Quality", "wpvn") . "</td><td>
			<select name='wpvn_image_quality'>
				<option value='90' ". selected( $wpvnoption['wpvn_image_quality'], 90 , false) .">90</option>
				<option value='95' ". selected( $wpvnoption['wpvn_image_quality'], 95 , false) .">95</option>
				<option value='100' ". selected( $wpvnoption['wpvn_image_quality'], 100 , false) .">100</option>
			</select> %</td></tr>
		  
		  <tr><td>" . __("Disable & Remove Menu Comments", "wpvn") . "<br /><small>" . __("Disable support for comments and trackbacks in post types", "wpvn") . "</small></td><td><input type='checkbox' name='wpvn_disable_comments' value='1' " . checked($wpvnoption['wpvn_disable_comments'], '1', false) . " /></td></tr>
		  
		  <tr><td>" . __("Limit Post Revisions", "wpvn") . "<br/><small>" . __("Set how many revisions you want to keep", "wpvn") . "</small></td><td><input type='text' class='widefat' size='10' name='wpvn_post_revisions' value='" . $wpvnoption['wpvn_post_revisions'] . "' /></td></tr>
		  
          <tr><td><span><input class='button button-primary button-large' type='submit' name='wpvn_save_options' value='" . __("Save Options", "wpvn") . "' /></span></td></tr>
          </table>
		  
          <table class='widefat' style='margin-top: 20px; border:1px solid #A3B745;'>
          <thead style='background: #A3B745;'><th colspan='2'><font color='#fff'>WP Admin Notices</font></th></tr>
          </thead>
		  
		  <tr><td>" . __("Remove All Dashboard", "wpvn") . "</td><td><input type='checkbox' name='wpvn_remove_dashboard' value='1' " . checked($wpvnoption['wpvn_remove_dashboard'], '1', false) . " /> </td></tr>
		  
		  <tr><td colspan='2'>" . __("Add Notice to Dashboard", "wpvn") . "</td></tr>
		  ";
		  
	echo "<tr><td colspan='2'>";
	wp_editor( stripslashes($wpvnoption['wpvn_dashboard_notice']), 'wpvn_dashboard_notice', $args );
	echo "</td></tr>";
		  
	echo "<tr><td><span><input class='button button-primary button-large' type='submit' name='wpvn_save_options' value='" . __("Save Options", "wpvn") . "' /></span></td></tr>
          </table>
		  
          <table class='widefat' style='margin-top: 20px; border:1px solid #000;'>
          <thead style='background: #000;'><th colspan='2'><font color='#fff'>WP Shortcode</font></th></tr>
          </thead>
		  
		  <tr><td colspan='2'>" . __("Add <code>[wpextra]</code> to post / page", "wpvn") . " <sup>PRO</sup></td></tr>
		  ";
		  
	echo "<tr><td colspan='2'>";
	wp_editor( stripslashes($wpvnoption['wpvn_shortcode']), 'wpvn_shortcode', $args );
	echo "</td></tr>";
		  
	echo "<tr><td><span><input class='button button-primary button-large' type='submit' name='wpvn_save_options' value='" . __("Save Options", "wpvn") . "' /></span></td></tr>
          </table>
		  
		  
          <table class='widefat' style='margin-top: 20px; border:1px solid #DD823B;'>
          <thead style='background: #DD823B;'><th colspan='2'><font color='#fff'>WP SMTP (Only Gmail)</font></th></tr>
          </thead>
		  
          <tr><td colspan='2'>Test by <a href='" . admin_url( 'admin.php?page=wpcf7' ) . "'>" . __("Contact Form 7", "wpvn") . "</a> after \"Save Options\"</td></tr>
		  
		  <tr><td width='50%'>" . __("Username", "wpvn") . "</td><td><input type='text' class='widefat' name='wpvn_user_gmail' value='" . $wpvnoption['wpvn_user_gmail'] . "' /></td></tr>
		  
		  <tr><td>" . __("Password", "wpvn") . "</td><td><input type='password' class='widefat' name='wpvn_pass_gmail' value='" . $wpvnoption['wpvn_pass_gmail'] . "' /></td></tr>

          <tr><td><span><input class='button button-primary button-large' type='submit' name='wpvn_save_options' value='" . __("Save Options", "wpvn") . "' /></span></td></tr>
          </table>
		  
		  </td>
		  
		  <td valign='top' width='45%'>
		  
          <table class='widefat' style='border:1px solid #ff2200;'>
          <thead style='background: #ff2200;'><th colspan='2'><font color='#fff'>WP Backend</font></th></tr>
          </thead>
		  
		  <tr><td colspan='2'>Click <a href='" . admin_url( 'options-permalink.php' ) . "'>" . __( 'Options Permalink' ) . "</a> after \"Save Options\"</td></tr>
		  
		  <tr bgcolor='#efefef'><td>" . __("HTTPS (SSL)", "wpvn") . " <sup>PRO</sup><br /><small>Adds https and removing http & https from links</small></td><td><input type='checkbox' name='wpvn_ssl' value='1' " . checked($wpvnoption['wpvn_ssl'], '1', false) . " /></td></tr>
		  
		  <tr bgcolor='#efefef'><td>" . __("Login URL", "wpvn") . " <sup>PRO</sup><br /><small>Change Admin Login URL (wp-admin & wp-login.php)</small></td><td><input type='checkbox' name='wpvn_admin_slug' value='1' " . checked($wpvnoption['wpvn_admin_slug'], '1', false) . " /> </td></tr>
		  
		  <tr bgcolor='#efefef'><td>" . __("Add .html to Page", "wpvn") . " <sup>PRO</sup></td><td><input type='checkbox' name='wpvn_page_html' value='1' " . checked($wpvnoption['wpvn_page_html'], '1', false) . " /></td></tr>
		  
		  <tr><td>" . __("Login Logo", "wpvn") . "<br/><small>" . __("Ex: abc.com/logo.jpg . Recommended: <code>84x84</code>", "wpvn") . "</small></td><td><input type='text' class='widefat' name='wpvn_admin_logo' value='" . $wpvnoption['wpvn_admin_logo'] . "' /></td></tr>
		  
		  <tr><td>" . __("Login Background Color", "wpvn") . "<br/><small>" . __("Ex: <code>#CCC</code> or <code>Grey</code>", "wpvn") . "</small></td><td><input type='text' class='widefat' name='wpvn_admin_background' value='" . $wpvnoption['wpvn_admin_background'] . "' /></td></tr>
		  
		  <tr><td>" . __("Login Button Color", "wpvn") . "<br/><small>" . __("Ex: <code>#CCC</code> or <code>Grey</code>", "wpvn") . "</small></td><td><input type='text' class='widefat' name='wpvn_admin_button' value='" . $wpvnoption['wpvn_admin_button'] . "' /></td></tr>
		  
		  <tr><td>" . __("Hide admin bar from front end for non admin?", "wpvn") . "</td><td>
			<select name='wpvn_hide_admin_bar'>
				<option value='1' ". selected( $wpvnoption['wpvn_hide_admin_bar'], 1 , false) .">None</option>
				<option value='2' ". selected( $wpvnoption['wpvn_hide_admin_bar'], 2 , false) .">Disable All</option>
				<option value='3' ". selected( $wpvnoption['wpvn_hide_admin_bar'], 3 , false) .">Enable Admin</option>
			</select></td></tr>
		  
		  <tr><td width='50%'>" . __("Remove Icon WordPress", "wpvn") . "</td><td><input type='checkbox' name='wpvn_remove_wp_logo' value='1' " . checked($wpvnoption['wpvn_remove_wp_logo'], '1', false) . " /></td></tr>
		  
		  <tr><td>" . __("Link Avatar Defaults", "wpvn") . "</td><td><input type='text' class='widefat' name='wpvn_avatar_defaults' value='" . $wpvnoption['wpvn_avatar_defaults'] . "' /> </td></tr>
		  
		  <tr><td>" . __("Remove unnecessary links from wp_head?", "wpvn") . "</td><td><input type='checkbox' name='wpvn_remove_head_link' value='1' " . checked($wpvnoption['wpvn_remove_head_link'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Remove Menu Tools", "wpvn") . "</td><td><input type='checkbox' name='wpvn_remove_menu_tools' value='1' " . checked($wpvnoption['wpvn_remove_menu_tools'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Disable RSS Feeds?", "wpvn") . "</td><td><input type='checkbox' name='wpvn_disable_feed' value='1' " . checked($wpvnoption['wpvn_disable_feed'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Enable Gzip?", "wpvn") . "</td><td><input type='checkbox' name='wpvn_enable_gzip' value='1' " . checked($wpvnoption['wpvn_enable_gzip'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Disable back end access for non admin users?", "wpvn") . "<br /><small>" . __("They will be redirected to home page.", "wpvn") . "</small></td><td><input type='checkbox' name='wpvn_back_access' value='1' " . checked($wpvnoption['wpvn_back_access'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Change Admin footer?", "wpvn") . "<br/><small>" . __("Set your name", "wpvn") . "</small></td><td><input type='text' class='widefat' name='wpvn_admin_footer' value='" . $wpvnoption['wpvn_admin_footer'] . "' /></td></tr>
		  
		  <tr><td>" . __("Disable the theme/plugin editor in Admin?", "wpvn") . "<br /><small>" . __("If not set in wp-config.php", "wpvn") . "</small></td><td><input type='checkbox' name='wpvn_disallow_file_edit' value='1' " . checked($wpvnoption['wpvn_disallow_file_edit'], '1', false) . " /></td></tr>
		  
		  <tr><td>" . __("Disallow anything that creates, deletes, or updates core, plugin, or theme files.?", "wpvn") . "</td><td><input type='checkbox' name='wpvn_disallow_file_mods' value='1' " . checked($wpvnoption['wpvn_disallow_file_mods'], '1', false) . " /></td></tr>
		  
		  <tr><td>" . __("Disable core & translate auto updating", "wpvn") . "</td><td><input type='checkbox' name='wpvn_auto_update' value='1' " . checked($wpvnoption['wpvn_auto_update'], '1', false) . " /></td></tr>
		  		  
		  <tr><td>" . __("Disable XMLRPC", "wpvn") . "<br /><small>" . __("This could cause security issues and can be exploited by hackers", "wpvn") . "</small></td><td><input type='checkbox' name='wpvn_disable_xmlrpc' value='1' " . checked($wpvnoption['wpvn_disable_xmlrpc'], '1', false) . " /></td></tr>
		  
		  <tr><td>" . __("Disable Admin nag", "wpvn") . "<br /><small>" . __("Only shown to admin.", "wpvn") . "</small></td><td><input type='checkbox' name='wpvn_disable_admin_nag' value='1' " . checked($wpvnoption['wpvn_disable_admin_nag'], '1', false) . " /></td></tr>
		  
		  <tr><td>" . __("Remove wordpress version number?", "wpvn") . "</td><td><input type='checkbox' name='wpvn_remove_version' value='1' " . checked($wpvnoption['wpvn_remove_version'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Remove Help", "wpvn") . "</td><td><input type='checkbox' name='wpvn_remove_help' value='1' " . checked($wpvnoption['wpvn_remove_help'], '1', false) . " /> </td></tr>
		  
		  <tr><td>" . __("Remove All Screen Options", "wpvn") . "</td><td><input type='checkbox' name='wpvn_remove_show_screen' value='1' " . checked($wpvnoption['wpvn_remove_show_screen'], '1', false) . " /> </td></tr>
		  ";
			
	echo "<tr><td><span><input class='button button-primary button-large' type='submit' name='wpvn_save_options' value='" . __("Save Options", "wpvn") . "' /></span></td></tr>
          </table>
		  
		  
          <table class='widefat' style='margin-top: 20px; border:1px solid #7c008c;'>
          <thead style='background: #7c008c;'><th colspan='2'><font color='#fff'>WP Themes</font></th></tr>
          </thead>
		
		  <tr><td width='40%'>" . __("Scripts in Header", "wpvn") . "<br /><small>" . __("To be inserted in the <code>&lt;head&gt;</code> section.<br>Ex: Google Analytic", "wpvn") . "</small></td><td><textarea name='wpvn_add_header' class='widefat' rows='8'>" . stripslashes($wpvnoption['wpvn_add_header']) . "</textarea></td></tr>
		
		  <tr><td>" . __("Scripts in Footer", "wpvn") . "<br /><small>" . __("To be inserted above the <code>&lt;/body&gt;</code> tag.<br>Ex: Javascript") . "</small></td><td><textarea name='wpvn_add_footer' class='widefat' rows='8'>" . stripslashes($wpvnoption['wpvn_add_footer']) . "</textarea></td></tr>
		  	  
		  <tr><td colspan='2'>" . __("and more ...", "wpvn") . "</td></tr>
		  
		  <tr><td>" . __("Buy me a Beer 🍻 / Coffee ☕️ !!!", "wpvn") . "<br/><small>" . __("Remove donate on Menu Bar", "wpvn") . "</small></td><td><input type='checkbox' name='wpvn_copyright' value='1' " . checked($wpvnoption['wpvn_copyright'], '1', false) . " /> Donate WPVN Team <a href='https://www.paypal.me/wordpressvn' target='_blank'>" . __("(Paypal)", "wpvn") . "</a></td></tr>

          <tr><td><span><input class='button button-primary button-large' type='submit' name='wpvn_save_options' value='" . __("Save Options", "wpvn") . "' /></span></td></tr>
          </table>
		  
		  </td>
		  
		  
		  </tr>
          </table>
		  
		  <div class='clear-option'>
		  <input class='button button-red button-large' type='submit' onclick='return confirm(\"Do you want to clear all? \")' name='wpvn_delete_options' value='" . __("Clear Option", "wpvn") . "' />
		  </div>
		  </form>
          </div>";
}

function wpvnsave()
{
    if (isset($_POST['wpvn_save_options'])) {
        $wpvnsaveOps = array(
            'wpvn_image_quality' => (isset($_POST['wpvn_image_quality']) ? $_POST['wpvn_image_quality']: ''),
            'wpvn_image_limit' => (isset($_POST['wpvn_image_limit']) ? $_POST['wpvn_image_limit']: ''),
            'wpvn_image_maximum_height' => (isset($_POST['wpvn_image_maximum_height']) ? $_POST['wpvn_image_maximum_height']: ''),
            'wpvn_image_maximum_width' => (isset($_POST['wpvn_image_maximum_width']) ? $_POST['wpvn_image_maximum_width']: ''),
            'wpvn_add_header' => (isset($_POST['wpvn_add_header']) ? $_POST['wpvn_add_header']: ''),
            'wpvn_add_footer' => (isset($_POST['wpvn_add_footer']) ? $_POST['wpvn_add_footer']: ''),
            'wpvn_remove_menu_tools' => (isset($_POST['wpvn_remove_menu_tools']) ? $_POST['wpvn_remove_menu_tools']: ''),
            'wpvn_disable_comments' => (isset($_POST['wpvn_disable_comments']) ? $_POST['wpvn_disable_comments']: ''),
            'wpvn_ssl' => (isset($_POST['wpvn_ssl']) ? $_POST['wpvn_ssl']: ''),
            'wpvn_clone_post' => (isset($_POST['wpvn_clone_post']) ? $_POST['wpvn_clone_post']: ''),
            'wpvn_page_html' => (isset($_POST['wpvn_page_html']) ? $_POST['wpvn_page_html']: ''),
            'wpvn_auto_update' => (isset($_POST['wpvn_auto_update']) ? $_POST['wpvn_auto_update']: ''),
            'wpvn_user_gmail' => (isset($_POST['wpvn_user_gmail']) ? $_POST['wpvn_user_gmail']: ''),
            'wpvn_pass_gmail' => (isset($_POST['wpvn_pass_gmail']) ? $_POST['wpvn_pass_gmail']: ''),
            'wpvn_shortcode' => (isset($_POST['wpvn_shortcode']) ? $_POST['wpvn_shortcode']: ''),
            'wpvn_set_image_meta' => (isset($_POST['wpvn_set_image_meta']) ? $_POST['wpvn_set_image_meta']: ''),
            'wpvn_disable_xmlrpc' => (isset($_POST['wpvn_disable_xmlrpc']) ? $_POST['wpvn_disable_xmlrpc']: ''),
            'wpvn_avatar_defaults' => (isset($_POST['wpvn_avatar_defaults']) ? $_POST['wpvn_avatar_defaults']: ''),
            'wpvn_copyright' => (isset($_POST['wpvn_copyright']) ? $_POST['wpvn_copyright']: ''),
            'wpvn_remove_show_screen' => (isset($_POST['wpvn_remove_show_screen']) ? $_POST['wpvn_remove_show_screen']: ''),
            'wpvn_dashboard_notice' => (isset($_POST['wpvn_dashboard_notice']) ? $_POST['wpvn_dashboard_notice']: ''),
            'wpvn_remove_dashboard' => (isset($_POST['wpvn_remove_dashboard']) ? $_POST['wpvn_remove_dashboard']: ''),
            'wpvn_remove_help' => (isset($_POST['wpvn_remove_help']) ? $_POST['wpvn_remove_help']: ''),
            'wpvn_admin_slug' => (isset($_POST['wpvn_admin_slug']) ? $_POST['wpvn_admin_slug']: ''),
            'wpvn_disable_emojis' => (isset($_POST['wpvn_disable_emojis']) ? $_POST['wpvn_disable_emojis']: ''),
            'wpvn_mce' => (isset($_POST['wpvn_mce']) ? $_POST['wpvn_mce']: ''),
            'wpvn_admin_button' => (isset($_POST['wpvn_admin_button']) ? $_POST['wpvn_admin_button']: ''),
            'wpvn_admin_background' => (isset($_POST['wpvn_admin_background']) ? $_POST['wpvn_admin_background']: ''),
            'wpvn_remove_wp_logo' => (isset($_POST['wpvn_remove_wp_logo']) ? $_POST['wpvn_remove_wp_logo']: ''),
            'wpvn_admin_logo' => (isset($_POST['wpvn_admin_logo']) ? $_POST['wpvn_admin_logo']: ''),
            'wpvn_auto_save_images' => (isset($_POST['wpvn_auto_save_images']) ? $_POST['wpvn_auto_save_images']: ''),
            'wpvn_donotcopy' => (isset($_POST['wpvn_donotcopy']) ? $_POST['wpvn_donotcopy']: ''),
            'wpvn_allow_svg' => (isset($_POST['wpvn_allow_svg']) ? $_POST['wpvn_allow_svg']: ''),
            'wpvn_remove_gutenberg' => (isset($_POST['wpvn_remove_gutenberg']) ? $_POST['wpvn_remove_gutenberg']: ''),
            'wpvn_button_post' => (isset($_POST['wpvn_button_post']) ? $_POST['wpvn_button_post']: ''),
            'wpvn_post_revisions' => (isset($_POST['wpvn_post_revisions']) ? $_POST['wpvn_post_revisions']: ''),
            'wpvn_admin_footer' => (isset($_POST['wpvn_admin_footer']) ? $_POST['wpvn_admin_footer']: ''),
            'wpvn_remove_head_link' => (isset($_POST['wpvn_remove_head_link']) ? $_POST['wpvn_remove_head_link']: ''),
            'wpvn_hide_admin_bar' => (isset($_POST['wpvn_hide_admin_bar']) ? $_POST['wpvn_hide_admin_bar']: ''),
            'wpvn_back_access' => (isset($_POST['wpvn_back_access']) ? $_POST['wpvn_back_access']: ''),
            'wpvn_disable_feed' => (isset($_POST['wpvn_disable_feed']) ? $_POST['wpvn_disable_feed']: ''),
            'wpvn_enable_gzip' => (isset($_POST['wpvn_enable_gzip']) ? $_POST['wpvn_enable_gzip']: ''),
            'wpvn_disallow_file_edit' => (isset($_POST['wpvn_disallow_file_edit']) ? $_POST['wpvn_disallow_file_edit']: ''),
            'wpvn_disallow_file_mods' => (isset($_POST['wpvn_disallow_file_mods']) ? $_POST['wpvn_disallow_file_mods']: ''),
            'wpvn_disable_admin_nag' => (isset($_POST['wpvn_disable_admin_nag']) ? $_POST['wpvn_disable_admin_nag']: ''),
            'wpvn_remove_version' => (isset($_POST['wpvn_remove_version']) ? $_POST['wpvn_remove_version']: '')
        );
        update_option('wpvn_options', $wpvnsaveOps);
        return true;
    }
	if (isset($_POST['wpvn_delete_options'])) {
        $wpvnsaveOps = array(
            'wpvn_image_quality' => '90',
            'wpvn_image_limit' => '',
            'wpvn_image_maximum_height' => '',
            'wpvn_image_maximum_width' => '',
            'wpvn_add_header' => '',
			'wpvn_add_footer' => '',
			'wpvn_remove_menu_tools' => '0',
			'wpvn_disable_comments' => '0',
			'wpvn_ssl' => '0',
			'wpvn_clone_post' => '0',
			'wpvn_page_html' => '0',
			'wpvn_auto_update' => '0',
			'wpvn_user_gmail' => '',
			'wpvn_pass_gmail' => '',
			'wpvn_shortcode' => '',
			'wpvn_set_image_meta' => '0',
			'wpvn_disable_xmlrpc' => '0',
			'wpvn_avatar_defaults' => '',
			'wpvn_copyright' => '0',
			'wpvn_remove_show_screen' => '0',
			'wpvn_remove_dashboard' => '0',
			'wpvn_dashboard_notice' => '',
			'wpvn_remove_help' => '0',
			'wpvn_admin_slug' => '0',
			'wpvn_disable_emojis' => '0',
			'wpvn_mce' => '0',
			'wpvn_admin_button' => '',
			'wpvn_admin_background' => '',
			'wpvn_admin_logo' => '',
			'wpvn_remove_wp_logo' => '',
			'wpvn_auto_save_images' => '0',
			'wpvn_donotcopy' => '0',
			'wpvn_allow_svg' => '0',
			'wpvn_button_post' => '0',
			'wpvn_remove_gutenberg' => '0',
			'wpvn_post_revisions' => '10',
			'wpvn_admin_footer' => '',
			'wpvn_remove_head_link' => '0',
			'wpvn_hide_admin_bar' => '0',
			'wpvn_back_access' => '0',
			'wpvn_disable_feed' => '0',
			'wpvn_enable_gzip' => '0',
			'wpvn_disallow_file_edit' => '0',
			'wpvn_disallow_file_mods' => '0',
			'wpvn_disable_admin_nag' => '0',
			'wpvn_remove_version' => '0'
        );
        delete_option('wpvn_options', $wpvnsaveOps);
        return true;
    }
    return false;
}
function wpvn_all_options()
{
    $wpvnoptions = array(
		'wpvn_image_quality' => '90',
		'wpvn_image_limit' => '',
		'wpvn_image_maximum_height' => '',
		'wpvn_image_maximum_width' => '',
        'wpvn_add_header' => '',
        'wpvn_add_footer' => '',
        'wpvn_remove_menu_tools' => '0',
        'wpvn_disable_comments' => '0',
        'wpvn_ssl' => '0',
        'wpvn_clone_post' => '0',
        'wpvn_page_html' => '0',
        'wpvn_auto_update' => '0',
        'wpvn_user_gmail' => '',
        'wpvn_pass_gmail' => '',
        'wpvn_shortcode' => '',
        'wpvn_set_image_meta' => '0',
        'wpvn_disable_xmlrpc' => '0',
        'wpvn_avatar_defaults' => '',
        'wpvn_copyright' => '0',
        'wpvn_remove_show_screen' => '0',
        'wpvn_remove_dashboard' => '0',
        'wpvn_dashboard_notice' => '',
        'wpvn_remove_help' => '0',
        'wpvn_admin_slug' => '0',
        'wpvn_disable_emojis' => '0',
        'wpvn_mce' => '0',
        'wpvn_admin_button' => '',
        'wpvn_admin_background' => '',
        'wpvn_admin_logo' => '',
        'wpvn_remove_wp_logo' => '',
        'wpvn_auto_save_images' => '0',
        'wpvn_donotcopy' => '0',
        'wpvn_allow_svg' => '0',
        'wpvn_button_post' => '0',
        'wpvn_remove_gutenberg' => '0',
        'wpvn_post_revisions' => '10',
        'wpvn_admin_footer' => '',
        'wpvn_remove_head_link' => '0',
        'wpvn_hide_admin_bar' => '0',
        'wpvn_back_access' => '0',
        'wpvn_disable_feed' => '0',
        'wpvn_enable_gzip' => '0',
        'wpvn_disallow_file_edit' => '0',
        'wpvn_disallow_file_mods' => '0',
        'wpvn_disable_admin_nag' => '0',
        'wpvn_remove_version' => '0'
    );
    
    //Get old values if they exist
    $wpvnops = get_option('wpvn_options');
    if (!empty($wpvnops)) {
        foreach ($wpvnops as $key => $option)
            $wpvnoptions[$key] = $option;
    }
    update_option('wpvn_options', $wpvnoptions);
    return $wpvnoptions;
}
?>